;Quest'opera e' stata rilasciata sotto la licenza Creative Commons
;Attribuzione-Non commerciale-Condividi allo stesso modo 2.5 Italia.
;
;Per leggere una copia della licenza visita il sito web
;http://creativecommons.org/licenses/by-nc-sa/2.5/it/ o spedisci una
;lettera a Creative Commons, 171 Second Street, Suite 300,
;San Francisco, California, 94105, USA.
;
;
;This work is licensed under the Creative Commons
;Attribution-Noncommercial-Share Alike 2.5 Italy License.
;
;To view a copy of this license, visit
;http://creativecommons.org/licenses/by-nc-sa/2.5/it/ or send a letter
;to Creative Commons, 171 Second Street, Suite 300, San Francisco,
;California, 94105, USA.

; ________________________________________________
; |       Controllo tastiera per 877 demo        |
; |______________________________________________|
; |   Src File                                   |
; |______________________________________________|
; |   Tipo      : ASM                            |
; |   Versione  : 0                              |
; |   Release   : 8                              |
; |   Autore    : Lain Walter                    |
; |   Data      : 03/11/09                       |
; |______________________________________________|

;_______________________________________________________Init della tastiera
; Routine di init della tastiera. Azzera le variabili
;Registri modificati:
;       Sistema
;       b_KEYB_STAT
;       b_SWITCH_11
;       b_SWITCH_12
;       b_SWITCH_13
;       b_SWITCH_14
;       b_SWITCH_21
;       b_SWITCH_22
;       b_SWITCH_23
;       b_SWITCH_24
;       b_SWITCH_31
;       b_SWITCH_32
;       b_SWITCH_33
;       b_SWITCH_34
;       b_SWITCH_41
;       b_SWITCH_42
;       b_SWITCH_43
;       b_SWITCH_44
Keyb_Init:
        CLRF l_KEYB_STAT
        CLRF l_KEYB_STAT+1
        CLRF l_KEYB_STAT+2
        CLRF l_KEYB_STAT+3
        MOVLF 0x01,b_SWITCH_11
        MOVWF b_SWITCH_12
        MOVWF b_SWITCH_13
        MOVWF b_SWITCH_14
        MOVWF b_SWITCH_21
        MOVWF b_SWITCH_22
        MOVWF b_SWITCH_23
        MOVWF b_SWITCH_24
        MOVWF b_SWITCH_31
        MOVWF b_SWITCH_32
        MOVWF b_SWITCH_33
        MOVWF b_SWITCH_34
        MOVWF b_SWITCH_41
        MOVWF b_SWITCH_42
        MOVWF b_SWITCH_43
        MOVWF b_SWITCH_44
        RETURN


;_______________________________________________________Legge tastiera
; Imposta I/O e legge la tastiera
;Dati in ingresso:
;       (n/a)
;Registri modificati:
;       Sistema
;       l_KEYB_STAT
;       R0H
;       R0L
;       R1H
;       b_SWITCH_11
;       b_SWITCH_12
;       b_SWITCH_13
;       b_SWITCH_14
;       b_SWITCH_21
;       b_SWITCH_22
;       b_SWITCH_23
;       b_SWITCH_24
;       b_SWITCH_31
;       b_SWITCH_32
;       b_SWITCH_33
;       b_SWITCH_34
;       b_SWITCH_41
;       b_SWITCH_42
;       b_SWITCH_43
;       b_SWITCH_44
Keyb_Read:
        BANKSEL TRISD                       ;BANK1
        MOVLF c_TRISDK_VALUE,TRISD          ; imposta D0-D3 come OUT, D4-D7 come IN
        BANKSEL PORTD                       ;BANK0
        BCF c_S0_PORT,c_S0_PIN              ;imposta indirizzo tastiera
        BSF c_S1_PORT,c_S1_PIN
        BCF c_S2_PORT,c_S2_PIN
        BCF c_S3_PORT,c_S3_PIN
        BSF c_CK_PORT,c_CK_PIN              ;alza il pin clock
        BCF c_CK_PORT,c_CK_PIN              ;abbassa il pin clock
        BCF c_OE_PORT,c_OE_PIN              ;attiva OE indirizzi
        ;indirizzo impostato
        CLRF R0H                            ;contatore colonna
        MOVLF 0x01,R0L                      ;contatore riga
        MOVLF b_SWITCH_11,FSR               ;counter primo tasto
KB_CK01 MOVFF R0L,PORTD                     ;carica posizione riga
        BSF c_CK_PORT,c_CK_PIN              ;alza il pin clock
        BCF c_CK_PORT,c_CK_PIN              ;abbassa il pin clock
        ;riga impostata
        BSF c_CK_PORT,c_CK_PIN              ;alza il pin clock
        BCF c_CK_PORT,c_CK_PIN              ;abbassa il pin clock
        ;dato valido
        MOVFF PORTD,R1H                     ;copia il dato
        CLRC
        RRF R1H,f                           ;shift di 4, il dato si trova in R1L,0
        RRF R1H,f
        RRF R1H,f
        RRF R1H,f
KB_CK02 BTFSC R1H,0                         ;controlla se SW premuto
        GOTO KB_SW_1                        ; si
        DECFSZ INDF,f                       ; no, decrementa buffer
        GOTO KB_CK03                        ;  non e' a zero, prosegue
        INCF INDF,f                         ;  e' a zero, incrementa di 1
        BTFSC l_KEYB_STAT+2,0               ;controlla se era gia' "non premuto"
        BCF l_KEYB_STAT+2,0                 ; no, imposta condizione
        BCF l_KEYB_STAT,0                   ;
        GOTO KB_CK03                        ;prosegue
KB_SW_1 INCF INDF,f                         ;incrementa di 1
        BTFSS INDF,c_KEYB_BIT               ;controlla se buffer pieno
        GOTO KB_CK03                        ; no, prosegue
        DECF INDF,f                         ; si, decrementa di 1
        BTFSS l_KEYB_STAT+2,0               ;controlla se era gia' "premuto"
        BSF l_KEYB_STAT+2,0                 ; no, imposta condizione
        BSF l_KEYB_STAT,0                   ;
KB_CK03 INCF FSR,f                          ;seleziona prossimo counter tasto
        INCF R0H,f                          ;incrementa contatore colonna
        BTFSS R0H,2                         ;contatore = 4?
        GOTO KB_CK04                        ; no
        CLRF R0H                            ; si, azzera contatore
        CLRC
        RLF R0L,f                           ;seleziona prossima riga
        BTFSC R0L,4                         ;quinta riga?
        GOTO KB_CK05                        ; si, fine
KB_CK04 CLRC                                ;porta status in bit0
        RRF l_KEYB_STAT+1,f
        RRF l_KEYB_STAT,f
        BTFSC STATUS,C
        BSF l_KEYB_STAT+1,7
        CLRC                                ;porta status precedente in bit0
        RRF l_KEYB_STAT+3,f
        RRF l_KEYB_STAT+2,f
        BTFSC STATUS,C
        BSF l_KEYB_STAT+3,7
        CLRC                                ;porta il pin in bit0
        RRF R1H,f
        MOVF R0H,w
        BNZ KB_CK02
        GOTO KB_CK01
KB_CK05 CLRF PORTD                          ;azzera uscite
        CLRC                                ;sistema i bytes di controllo tastiera
        RRF l_KEYB_STAT+1,f
        RRF l_KEYB_STAT,f
        BTFSC STATUS,C
        BSF l_KEYB_STAT+1,7
        CLRC
        RRF l_KEYB_STAT+3,f
        RRF l_KEYB_STAT+2,f
        BTFSC STATUS,C
        BSF l_KEYB_STAT+3,7
        BSF c_CK_PORT,c_CK_PIN              ;alza il pin clock
        BCF c_CK_PORT,c_CK_PIN              ;abbassa il pin clock
        ;port impostato
        BCF c_S1_PORT,c_S1_PIN              ;riporta ad "idle" l'indirizzo
        BCF c_OE_PORT,c_OE_PIN              ;disattiva OE indirizzi
        RETURN
